#include <Blackfin_definitions.h>
#include <functions.h>
#include<SDDefinitions.h>


extern int Done80Cycles;
extern char COREorDMA;			//0: Sensor request; 1: No sensor request
extern int CommandBuffer [9];
extern int ResponseBuffer [9];
extern int SPITransferStatus;
extern int SPITransferCount;
extern volatile int DataBlockReceived;
extern volatile int DataBlockTransmitted;
extern int BusyCheck;
extern int N;
int busy = 0;
extern char InterruptCause;
extern int TokenFlag;
extern char dest[515];
int ReadTokenCount = 0;
volatile int ReadToken = 0;



//--------------------------------------------------------------------------//
// Function:	IsrSPI														//
//																			//
// Parameters:	None														//
//																			//
// Return:		None														//
//																			//
// Description:	This ISR checks whether the interrupt is initiated by a 	//
//				Core/ DMA operation. For a Core operation, it sends the 	//
//				values that are pre-written into the Global command array.	//
//				It calls a function to disable SPI before return. 			//
//--------------------------------------------------------------------------//

EX_INTERRUPT_HANDLER (SDInitIsr)
{   
    
    switch(InterruptCause)
    {
      	case 1: 								//SPI Core mode
      			SPITransferCount++;
		    	if(SPITransferCount <= 8)
		    	{
		    		*pSPI_TDBR = CommandBuffer[SPITransferCount];
		    	}
		    	
    
		    	if(SPITransferCount >= N)
		    	{
		        	SPITransferStatus = 0;
		        	DisableCoreSPI();
		    	}
		    	ResponseBuffer[SPITransferCount] = *pSPI_RDBR;
		    	break;
      			
    	case 2: 								//DMA Receive
    			*pDMA7_IRQ_STATUS |= 0x0001;
		        Done80Cycles = 1;
		        DisableDmaSPI();
		        DataBlockReceived = 1;
    			break;
    	case 3: 								//Busy Check
    			if((busy == 1) && (ResponseBuffer[0] == 0xff))
				{
					BusyCheck = 1;
			    	DisableCoreSPI();
				}
				else if ((ResponseBuffer[0] == 0x0) && (busy ==0))
				{
					busy = 1;	
					ResponseBuffer[0] = *pSPI_RDBR;
				}
				else
				{
    				ResponseBuffer[0] = *pSPI_RDBR;
			    		    	
				}
            	
      			break;
    	case 4:
    			*pDMA7_IRQ_STATUS |= 0x0001;
   
    			DisableDmaSPITransmit();
    			DataBlockTransmitted = 1;
    			break;
    	case 5:
    			if(ResponseBuffer[0] == DATA_TOKEN)
    			{
    			   TokenFlag = 1;
    			   DisableCoreSPI(); 
    			   ReadToken = 1;   			        			    
    			}
    			else
    			{
    			    ReadTokenCount++;
    			    if(ReadTokenCount<=100)
    			    {
    			        ResponseBuffer[0] = *pSPI_RDBR;
    			        ReadToken = 0;
    			    }
    			    else
    			    {
    			    	ReadToken = 1;
    			    	DisableCoreSPI(); 
    			    }
    			}
    			break;
    	case 6:
    			SPITransferCount++;
		    	if(SPITransferCount <= 8)
		    	{
		    		*pSPI_TDBR = CommandBuffer[SPITransferCount];
		    	}
		    	
    
		    	if(SPITransferCount >= 10)
		    	{
		        	SPITransferStatus = 0;
		        	DisableCoreSPI();
		    	}
		    	ResponseBuffer[SPITransferCount] = *pSPI_RDBR;
		    	break;
		    	
		 case 7:
				ReadTokenCount++;
    			if(ReadTokenCount<=100)
    			{
    				if(ReadTokenCount>1)
    				{
    				while(!(*pSPI_STAT & 0x0020));				//Check for Rx Buffer Full
 					while(!(*pSPI_STAT & 0x0001));				//Check for SPIF
    				}
    					ResponseBuffer[0] = *pSPI_RDBR;
    					ReadToken = 0;
    			    	if(ResponseBuffer[0] == DATA_TOKEN)
    					{	
    						ReadToken = 1; 
    			   			TokenFlag = 1;
    			   			DisableCoreSPIWrite(); 
    			   			
    			   			break;  			        			    
    					}
    			    	*pSPI_TDBR = 0xFF;
    			    	
    			    	
    			 }
    			 else
    			 {
    			   	ReadToken = 1;
    			   	DisableCoreSPI(); 
    			 }
    			break;
				
				 
    			 
    	default: break;
    }
    
}


